# MATIO
MATLAB MAT file I/O library

## Build status
[![Build Status](https://drone.io/github.com/tbeu/matio/status.png)](https://drone.io/github.com/tbeu/matio/latest) [![Build Status](https://ci.appveyor.com/api/projects/status/heqkwuqllbh573i5/branch/master?svg=true)](https://ci.appveyor.com/project/tbeu/matio/branch/master)

## Table of Contents
1. [Introduction](#10-introduction)
  * 1.1[Contact](#11-contact)
  * 1.2 [Acknowledgements](#12-acknowledgements)
  * 1.3 [Contributing](#13-contributing)
  * 1.4 [Questions and Reporting Bugs](#14-questions-and-reporting-bugs)
2. [Building](#20-building)
  * 2.1 [Dependencies](#21-dependencies)
    * 2.1.1 [zlib](#211-zlib)
    * 2.1.2 [HDF5](#212-hdf5)
  * 2.2 [Building matio](#22-building-matio)
    * 2.2.1 [Quick Build Guide](#221-quick-build-guide)
    * 2.2.2 [Configure Options](#222-configure-options)
    * 2.2.3  [Visual Studio](#223-visual-studio)
    * 2.2.4 [Testsuite](#224-testsuite)
  * 2.3 [Platforms](#23-platforms)
3. [License](#30-license)

## 1.0 Introduction
matio is an open-source library for reading/writing MATLAB MAT files.
This library is designed for use by programs/libraries that do not have access or do not want to rely on MATLAB's shared library.

### 1.1 Contact
You can contact me (Christopher Hulbert) through email at chulbe2lsu@users.sourceforge.net.

### 1.2 Acknowledgements
The following people/organizations have helped in the development of matio through patches, bug reports, and/or testing:

* Jacco van Beek
* SGI in support of Interactive Supercomputing, Inc.
* Scilab ([http://www.scilab.org/](http://www.scilab.org/))
* Steven Leibman <sleibman@alum.mit.edu>
* OpenMEEG ([http://openmeeg.github.io/](http://openmeeg.github.io/))
* Modelica Association ([https://modelica.org/association](https://modelica.org/association))

### 1.3 Contributing
Part of my reason for releasing this software is I have many other projects to work on and have many features I would still like to implement. If you make changes, I would appreciate your contributions and more than likely will include them in future releases. If you are interested in collaborations, contact me via email (see Section [1.1](#11-contact)).

### 1.4 Questions and Reporting Bugs
Questions can be asked using the forums on the sourceforge site hosting matio ([http://sourceforge.net/projects/matio/forums](http://sourceforge.net/projects/matio/forums)).

Bugs, enhancements, etc. should be submitted using one of the trackers on the sourceforge page ([http://sourceforge.net/p/matio/_list/tickets](http://sourceforge.net/p/matio/_list/tickets)).

## 2.0 Building
This section describes how to build matio. Section [2.1](#21-dependencies) describes the dependencies, Section [2.2](#22-building-matio) how to build/test matio, and Section [2.3](#23-platforms) documents the platforms matio has been tested on.

### 2.1 Dependencies
MATIO has two optional dependencies. These are not required for the software to work, but without them some files may be unreadable. Zlib is required to read/write level 5 MAT files that use compression. HDF5 is required to work with newer MAT files that use the HDF5-format files.

#### 2.1.1 zlib
To support compressed MAT files, zlib 1.2.3 or greater is required. The zlib software can be downloaded from http://zlib.net/.

#### 2.1.2 HDF5
Support for MAT file version 7.3 requires the HDF5 library. This library can be downloaded from https://www.hdfgroup.org/. MATIO requires HDF5 version 1.8.x, and must be built with default API version 1.8 (i.e. `--with-default-api-version=v18`).

For Windows, the pre-compiled binaries can be used which also include a DLL of zlib to satisfy the zlib dependency.

### 2.2 Building matio
#### 2.2.1 Quick Build Guide
The primary method for building the software is using `configure` followed by `make`. After building, the testsuite can be executed to test the software using `make check`. The software can be installed using `make install`. For example,
```sh
$ tar zxf matio-X.Y.Z.tar.gz
$ cd matio-X.Y.Z
$ ./configure
$ make
$ make check
$ make install
```
If any of the tests in the testsuite fail, you should report the failure using the tracker (see Section [1.4](#14-questions-and-reporting-bugs)). You should attach the generated testsuite.log file to the bug report.

#### 2.2.2 Configure Options
The configure script used to build the software takes a number of options. This section describes the key options.

* `--enable-mat73=yes`
This flag en/disables the support for version 7.3 MAT files. The option only makes sense if built with HDF5 as support for version 7.3 files will be disabled if HDF5 is not available.

* `--enable-extended-sparse=yes`
Enable extended sparse matrix data types not supported in MATLAB. MATLAB only supports double-precision sparse data. With this flag, matio will read sparse data with other types (i.e. single-precision and integer types).
* `--with-matlab=DIR`
This option specifies the directory (DIR) with the 'matlab' program. With this option, the testsuite will check that the MAT files written by matio can be read into MATLAB. Without this, the test will only check that matio can read the file written and if successful the test will be skipped. If matio can not read the file, the test will fail.
* `--with-zlib=DIR`
This option specifies the prefix where zlib is installed (see Section [2.1.1](#211-zlib) for information about zlib).
* `--with-hdf5=DIR`
This option specifies the prefix where the HDF5 software is installed (see Section [2.1.2](#212-hdf5) for information about HDF5).
* `--with-default-file-ver=version`
This option sets the default MAT file version (4,5,7.3) that will be used when writing. The default file version is used by the Mat_Create macro and the Mat_CreateVer function when MAT_FT_DEFAULT is used for the version argument.
* `--with-libdir-suffix=suffix`
This option specifies a suffix to apply to library directories when installing and looking for dependent
libraries (i.e. HDF5 and zlib). For example, some multi-arch Linux distributions install 64-bit libraries into lib64 and 32-bit libraries into lib.

#### 2.2.3 Visual Studio
Visual Studio solutions are provided as [matio_vs2008.sln](visual_studio/matio_vs2008.sln) for VS2008 and as [matio.sln](visual_studio/matio.sln) for VS2010 (and newer). The solutions are set up to build a DLL of the matio library (libmatio.dll) and matdump tool and assume HDF5 is available in the directory specified by the HDF5_DIR environment variable. It is assumed that the **shared** libraries of HDF5 (and zlib) are available. If the **static** libraries of HDF5 (and zlib) are installed/built the macro `H5_BUILT_AS_STATIC_LIB` needs to be defined (instead of `H5_BUILT_AS_DYNAMIC_LIB`).

* The VS2008 solution was tested with Visual Studio 2008 and the [HDF5 1.8.12 Visual Studio pre-built Windows binaries](https://www.hdfgroup.org/ftp/HDF5/releases/hdf5-1.8.12/bin/windows/) (vs9shared) including zlib.
* The VS2010 solution was tested with Visual Studio 2010 and the [HDF5 1.8.13 Visual Studio pre-built Windows binaries](https://www.hdfgroup.org/ftp/HDF5/releases/hdf5-1.8.13/bin/windows/) (VS2010-shared) including zlib.
* The updated VS2010 solution was tested with Visual Studio 2015 and the [HDF5 1.8.16 Visual Studio pre-built Windows binaries](https://www.hdfgroup.org/ftp/HDF5/releases/hdf5-1.8.16/bin/windows/extra/) (vs2015-shared) including zlib.

#### 2.2.4 Testsuite
A testsuite is available when building with the GNU autotools. To run the testsuite, first configure and build matio. After building run `make check` to run the testsuite. If matio was built without zlib, the compressed variable tests will be skipped. If built without HDF5, the tests for version 7.3 MAT files will be skipped. If the path to the MATLAB application was not specified (`--with-matlab`), the write tests will fail if matio cannot read the file and skip if matio can read the file. The write tests will pass if MATLAB is available and can also read the file.

To report matio testsuite failures, compress the testsuite.log file in the test sub-directory of the build directory. Upload the compressed log file along with a bug report (see Section [1.4](#14-questions-and-reporting-bugs) for information on reporting bugs).

### 2.3 Platforms
The library has been tested/used on Linux, Windows, OS X, and AIX including both little-endian and big-endian architecture.

## 3.0 License
This software is provided under a Simplified BSD license. See the [COPYING](COPYING) file for details on the license.

!
! Copyright (C) 2005-2016   Christopher C. Hulbert
!
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
!    1. Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!    2. Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
! THIS SOFTWARE IS PROVIDED BY CHRISTOPHER C. HULBERT ``AS IS'' AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER C. HULBERT OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
! CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
! SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
! CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!

! FIXME: If stride is not present, assume 1

FUNCTION FMat_VarWriteDoubleData_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE PRECISION,INTENT(IN)              :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteDoubleData_0

FUNCTION FMat_VarWriteDoubleData_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(8),INTENT(IN),DIMENSION(:)          :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteDoubleData_1

FUNCTION FMat_VarWriteDoubleData_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(KIND=8),INTENT(IN),DIMENSION(:,:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteDoubleData_2

FUNCTION FMat_VarWriteDoubleData_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(KIND=8),INTENT(IN),DIMENSION(:,:,:) :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteDoubleData_3

FUNCTION FMat_VarWriteComplexDoubleData_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE COMPLEX,INTENT(IN)                :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexDoubleData_0

FUNCTION FMat_VarWriteComplexDoubleData_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE COMPLEX,INTENT(IN),DIMENSION(:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge
    DOUBLE PRECISION,DIMENSION(2*SIZE(d))    :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    d_split(1:SIZE(d))  = REAL(d)
    d_split(SIZE(d)+1:) = AIMAG(d)
    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d_split,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexDoubleData_1

FUNCTION FMat_VarWriteComplexDoubleData_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE COMPLEX,INTENT(IN),DIMENSION(:,:) :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge
    DOUBLE PRECISION,DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d_split,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexDoubleData_2

FUNCTION FMat_VarWriteComplexDoubleData_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                    :: err
    TYPE(mat_t)                                :: mat
    TYPE(matvar_t)                             :: matvar
    DOUBLE COMPLEX,INTENT(IN),DIMENSION(:,:,:) :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge
    DOUBLE PRECISION,DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d_split,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexDoubleData_3

FUNCTION FMat_VarWriteSingleData_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN)                       :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteSingleData_0

FUNCTION FMat_VarWriteSingleData_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN),DIMENSION(:)          :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteSingleData_1

FUNCTION FMat_VarWriteSingleData_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN),DIMENSION(:,:)        :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteSingleData_2

FUNCTION FMat_VarWriteSingleData_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN),DIMENSION(:,:,:)      :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteSingleData_3

FUNCTION FMat_VarWriteComplexSingleData_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    COMPLEX(4),INTENT(IN)                :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexSingleData_0

FUNCTION FMat_VarWriteComplexSingleData_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    COMPLEX(4),INTENT(IN),DIMENSION(:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge
    REAL(4),DIMENSION(2*SIZE(d))    :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    d_split(1:SIZE(d))  = REAL(d)
    d_split(SIZE(d)+1:) = AIMAG(d)
    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d_split,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexSingleData_1

FUNCTION FMat_VarWriteComplexSingleData_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    COMPLEX(4),INTENT(IN),DIMENSION(:,:) :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge
    REAL(4),DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d_split,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexSingleData_2

FUNCTION FMat_VarWriteComplexSingleData_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                    :: err
    TYPE(mat_t)                                :: mat
    TYPE(matvar_t)                             :: matvar
    COMPLEX(4),INTENT(IN),DIMENSION(:,:,:) :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge
    REAL(4),DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d_split,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteComplexSingleData_3

FUNCTION FMat_VarWriteInt32Data_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt32Data_0

FUNCTION FMat_VarWriteInt32Data_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN),DIMENSION(:)       :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt32Data_1

FUNCTION FMat_VarWriteInt32Data_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN),DIMENSION(:,:)     :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt32Data_2

FUNCTION FMat_VarWriteInt32Data_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN),DIMENSION(:,:,:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt32Data_3

FUNCTION FMat_VarWriteInt16Data_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt16Data_0

FUNCTION FMat_VarWriteInt16Data_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN),DIMENSION(:)       :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt16Data_1

FUNCTION FMat_VarWriteInt16Data_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN),DIMENSION(:,:)     :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt16Data_2

FUNCTION FMat_VarWriteInt16Data_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN),DIMENSION(:,:,:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt16Data_3

FUNCTION FMat_VarWriteInt8Data_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt8Data_0

FUNCTION FMat_VarWriteInt8Data_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN),DIMENSION(:)       :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt8Data_1

FUNCTION FMat_VarWriteInt8Data_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN),DIMENSION(:,:)     :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt8Data_2

FUNCTION FMat_VarWriteInt8Data_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN),DIMENSION(:,:,:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteInt8Data_3

FUNCTION FMat_VarWriteCharData_0(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    CHARACTER,INTENT(IN)                     :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteCharData_0

FUNCTION FMat_VarWriteCharData_1(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    CHARACTER(1),INTENT(IN),DIMENSION(:)     :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteCharData_1

FUNCTION FMat_VarWriteCharData_2(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    CHARACTER(1),INTENT(IN),DIMENSION(:,:)   :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteCharData_2

FUNCTION FMat_VarWriteCharData_3(mat,matvar,d,start,stride,edge) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    CHARACTER(1),INTENT(IN),DIMENSION(:,:,:) :: d
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: start
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: stride
    INTEGER,INTENT(IN),DIMENSION(:),OPTIONAL :: edge

    INTEGER,EXTERNAL                         :: fmat_varwritedata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varwritedata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varwritedata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarWriteCharData_3

!
! Copyright (C) 2005-2016   Christopher C. Hulbert
!
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
!    1. Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!    2. Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
! THIS SOFTWARE IS PROVIDED BY CHRISTOPHER C. HULBERT ``AS IS'' AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER C. HULBERT OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
! CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
! SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
! CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!

!   FIXME: Find a less memory hungry way to split the complex data

FUNCTION FMat_VarWriteDouble_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(8),INTENT(IN)                       :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteDouble_0

FUNCTION FMat_VarWriteDouble_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(8),INTENT(IN),DIMENSION(:)          :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteDouble_1

FUNCTION FMat_VarWriteDouble_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(8),INTENT(IN),DIMENSION(:,:)        :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteDouble_2

FUNCTION FMat_VarWriteDouble_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(8),INTENT(IN),DIMENSION(:,:,:)      :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteDouble_3

FUNCTION FMat_VarWriteComplexDouble_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE COMPLEX,INTENT(IN)                :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteComplexDouble_0

FUNCTION FMat_VarWriteComplexDouble_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE COMPLEX,INTENT(IN),DIMENSION(:)   :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress
    DOUBLE PRECISION,DIMENSION(2*SIZE(d))      :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    d_split(1:SIZE(d))  = REAL(d)
    d_split(SIZE(d)+1:) = AIMAG(d)
    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d_split,compress)
    END IF
END FUNCTION FMat_VarWriteComplexDouble_1

FUNCTION FMat_VarWriteComplexDouble_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    DOUBLE COMPLEX,INTENT(IN),DIMENSION(:,:) :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress
    DOUBLE PRECISION,DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d_split,compress)
    END IF
END FUNCTION FMat_VarWriteComplexDouble_2

FUNCTION FMat_VarWriteComplexDouble_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                    :: err
    TYPE(mat_t)                                :: mat
    TYPE(matvar_t)                             :: matvar
    DOUBLE COMPLEX,INTENT(IN),DIMENSION(:,:,:) :: d
    INTEGER,INTENT(IN),OPTIONAL                :: compress
    DOUBLE PRECISION,DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d_split,compress)
    END IF
END FUNCTION FMat_VarWriteComplexDouble_3

FUNCTION FMat_VarWriteSingle_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteSingle_0

FUNCTION FMat_VarWriteSingle_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN),DIMENSION(:)          :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteSingle_1

FUNCTION FMat_VarWriteSingle_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN),DIMENSION(:,:)        :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteSingle_2

FUNCTION FMat_VarWriteSingle_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    REAL(4),INTENT(IN),DIMENSION(:,:,:)      :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteSingle_3

FUNCTION FMat_VarWriteComplexSingle_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    COMPLEX(4),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteComplexSingle_0

FUNCTION FMat_VarWriteComplexSingle_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    COMPLEX(4),INTENT(IN),DIMENSION(:)  :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress
    REAL(4),DIMENSION(2*SIZE(d))             :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    d_split(1:SIZE(d))  = REAL(d)
    d_split(SIZE(d)+1:) = AIMAG(d)
    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d_split,compress)
    END IF
END FUNCTION FMat_VarWriteComplexSingle_1

FUNCTION FMat_VarWriteComplexSingle_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    COMPLEX(4),INTENT(IN),DIMENSION(:,:) :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress
    REAL(4),DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d_split,compress)
    END IF
END FUNCTION FMat_VarWriteComplexSingle_2

FUNCTION FMat_VarWriteComplexSingle_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                :: err
    TYPE(mat_t)                            :: mat
    TYPE(matvar_t)                         :: matvar
    COMPLEX(4),INTENT(IN),DIMENSION(:,:,:) :: d
    INTEGER,INTENT(IN),OPTIONAL            :: compress
    REAL(4),DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split

    INTEGER,EXTERNAL                       :: fmat_varwrite_c

    d_split(1:PRODUCT(SHAPE(d)))  = REAL(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    d_split(PRODUCT(SHAPE(d))+1:) = AIMAG(RESHAPE(d,(/2*PRODUCT(SHAPE(d))/)))
    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d_split,compress)
    END IF
END FUNCTION FMat_VarWriteComplexSingle_3

FUNCTION FMat_VarWriteInt32_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt32_0

FUNCTION FMat_VarWriteInt32_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN),DIMENSION(:)       :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt32_1

FUNCTION FMat_VarWriteInt32_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN),DIMENSION(:,:)     :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt32_2

FUNCTION FMat_VarWriteInt32_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(4),INTENT(IN),DIMENSION(:,:,:)   :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt32_3

FUNCTION FMat_VarWriteInt16_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt16_0

FUNCTION FMat_VarWriteInt16_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN),DIMENSION(:)       :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt16_1

FUNCTION FMat_VarWriteInt16_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN),DIMENSION(:,:)     :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt16_2

FUNCTION FMat_VarWriteInt16_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(2),INTENT(IN),DIMENSION(:,:,:)   :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt16_3

FUNCTION FMat_VarWriteInt8_0(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN)                    :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt8_0

FUNCTION FMat_VarWriteInt8_1(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN),DIMENSION(:)       :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt8_1

FUNCTION FMat_VarWriteInt8_2(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN),DIMENSION(:,:)     :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt8_2

FUNCTION FMat_VarWriteInt8_3(mat,matvar,d,compress) RESULT(err)
IMPLICIT NONE
    INTEGER                                  :: err
    TYPE(mat_t)                              :: mat
    TYPE(matvar_t)                           :: matvar
    INTEGER(1),INTENT(IN),DIMENSION(:,:,:)   :: d
    INTEGER,INTENT(IN),OPTIONAL              :: compress

    INTEGER,EXTERNAL                         :: fmat_varwrite_c

    IF ( .NOT. PRESENT(compress) ) THEN
        err = fmat_varwrite_c(mat,matvar,d,0)
    ELSE
        err = fmat_varwrite_c(mat,matvar,d,compress)
    END IF
END FUNCTION FMat_VarWriteInt8_3

!
! Copyright (C) 2005-2016   Christopher C. Hulbert
!
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
!    1. Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!    2. Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
! THIS SOFTWARE IS PROVIDED BY CHRISTOPHER C. HULBERT ``AS IS'' AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER C. HULBERT OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
! CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
! SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
! CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!

MODULE matio
!   Include the type definitions
    INCLUDE 'matio_t.inc'

!   C Routines
!    INTERFACE
!        INTEGER FUNCTION fmat_open_c(filename,mode,mat)
!            CHARACTER(LEN=*) :: filename
!            INTEGER          :: mode
!            TYPE(MAT_T)      :: mat
!        END FUNCTION fmat_open_c
!
!        INTEGER FUNCTION fmat_close_c(mat)
!            TYPE(MAT_T) :: mat
!        END FUNCTION fmat_close_c
!
!        INTEGER FUNCTION fmat_varcreate_c(rank,dims,name,class_type,      &
!                                          data_type,matvar)
!            INTEGER                 :: rank
!            INTEGER,DIMENSION(rank) :: dims
!            CHARACTER(LEN=*)        :: name
!            INTEGER                 :: class_type
!            INTEGER                 :: data_type
!            TYPE(MATVAR_T)          :: matvar
!        END FUNCTION fmat_varcreate_c
!
!        INTEGER FUNCTION fmat_varreadinfo_c(mat,matvar,dataptr,start,     &
!                                            stride,edge)
!            TYPE(mat_t)     :: mat
!            CHARACTER(*)    :: varname
!            TYPE(matvar_t)  :: matvar
!        END FUNCTION fmat_varreadinfo_c
!
!        INTEGER FUNCTION fmat_varfree_c(matvar)
!            TYPE(MATVAR_T) :: matvar
!        END FUNCTION fmat_varfree_c
!
!    END INTERFACE

    INTERFACE FMat_VarCreate
        MODULE PROCEDURE FMat_VarCreateA
        MODULE PROCEDURE FMat_VarCreateDouble0
        MODULE PROCEDURE FMat_VarCreateDouble1
        MODULE PROCEDURE FMat_VarCreateDouble2
        MODULE PROCEDURE FMat_VarCreateDouble3
        MODULE PROCEDURE FMat_VarCreateComplexDouble0
        MODULE PROCEDURE FMat_VarCreateComplexDouble1
        MODULE PROCEDURE FMat_VarCreateComplexDouble2
        MODULE PROCEDURE FMat_VarCreateComplexDouble3
        MODULE PROCEDURE FMat_VarCreateSingle0
        MODULE PROCEDURE FMat_VarCreateSingle1
        MODULE PROCEDURE FMat_VarCreateSingle2
        MODULE PROCEDURE FMat_VarCreateSingle3
        MODULE PROCEDURE FMat_VarCreateComplexSingle0
        MODULE PROCEDURE FMat_VarCreateComplexSingle1
        MODULE PROCEDURE FMat_VarCreateComplexSingle2
        MODULE PROCEDURE FMat_VarCreateComplexSingle3
        MODULE PROCEDURE FMat_VarCreateInt32_0
        MODULE PROCEDURE FMat_VarCreateInt32_1
        MODULE PROCEDURE FMat_VarCreateInt32_2
        MODULE PROCEDURE FMat_VarCreateInt32_3
        MODULE PROCEDURE FMat_VarCreateInt16_0
        MODULE PROCEDURE FMat_VarCreateInt16_1
        MODULE PROCEDURE FMat_VarCreateInt16_2
        MODULE PROCEDURE FMat_VarCreateInt16_3
        MODULE PROCEDURE FMat_VarCreateInt8_0
        MODULE PROCEDURE FMat_VarCreateInt8_1
        MODULE PROCEDURE FMat_VarCreateInt8_2
        MODULE PROCEDURE FMat_VarCreateInt8_3
        MODULE PROCEDURE FMat_VarCreateChar_0
        MODULE PROCEDURE FMat_VarCreateChar_1
        MODULE PROCEDURE FMat_VarCreateChar_2
        MODULE PROCEDURE FMat_VarCreateChar_3
    END INTERFACE FMat_VarCreate

    ! FMat_VarReadData(mat,matvar,d,start,stride,edge)
    INTERFACE FMat_VarReadData
        MODULE PROCEDURE FMat_VarReadDoubleData_0
        MODULE PROCEDURE FMat_VarReadDoubleData_1
        MODULE PROCEDURE FMat_VarReadDoubleData_2
        MODULE PROCEDURE FMat_VarReadDoubleData_3
        MODULE PROCEDURE FMat_VarReadComplexDoubleData_0
        MODULE PROCEDURE FMat_VarReadComplexDoubleData_1
        MODULE PROCEDURE FMat_VarReadComplexDoubleData_2
        MODULE PROCEDURE FMat_VarReadComplexDoubleData_3
        MODULE PROCEDURE FMat_VarReadSingleData_0
        MODULE PROCEDURE FMat_VarReadSingleData_1
        MODULE PROCEDURE FMat_VarReadSingleData_2
        MODULE PROCEDURE FMat_VarReadSingleData_3
        MODULE PROCEDURE FMat_VarReadComplexSingleData_0
        MODULE PROCEDURE FMat_VarReadComplexSingleData_1
        MODULE PROCEDURE FMat_VarReadComplexSingleData_2
        MODULE PROCEDURE FMat_VarReadComplexSingleData_3
        MODULE PROCEDURE FMat_VarReadInt32Data_0
        MODULE PROCEDURE FMat_VarReadInt32Data_1
        MODULE PROCEDURE FMat_VarReadInt32Data_2
        MODULE PROCEDURE FMat_VarReadInt32Data_3
        MODULE PROCEDURE FMat_VarReadInt16Data_0
        MODULE PROCEDURE FMat_VarReadInt16Data_1
        MODULE PROCEDURE FMat_VarReadInt16Data_2
        MODULE PROCEDURE FMat_VarReadInt16Data_3
        MODULE PROCEDURE FMat_VarReadInt8Data_0
        MODULE PROCEDURE FMat_VarReadInt8Data_1
        MODULE PROCEDURE FMat_VarReadInt8Data_2
        MODULE PROCEDURE FMat_VarReadInt8Data_3
        MODULE PROCEDURE FMat_VarReadCharData_0
        MODULE PROCEDURE FMat_VarReadCharData_1
        MODULE PROCEDURE FMat_VarReadCharData_2
        MODULE PROCEDURE FMat_VarReadCharData_3
    END INTERFACE

    INTERFACE FMat_VarWrite
        MODULE PROCEDURE FMat_VarWriteDouble_0
        MODULE PROCEDURE FMat_VarWriteDouble_1
        MODULE PROCEDURE FMat_VarWriteDouble_2
        MODULE PROCEDURE FMat_VarWriteDouble_3
        MODULE PROCEDURE FMat_VarWriteComplexDouble_0
        MODULE PROCEDURE FMat_VarWriteComplexDouble_1
        MODULE PROCEDURE FMat_VarWriteComplexDouble_2
        MODULE PROCEDURE FMat_VarWriteComplexDouble_3
        MODULE PROCEDURE FMat_VarWriteSingle_0
        MODULE PROCEDURE FMat_VarWriteSingle_1
        MODULE PROCEDURE FMat_VarWriteSingle_2
        MODULE PROCEDURE FMat_VarWriteSingle_3
        MODULE PROCEDURE FMat_VarWriteComplexSingle_0
        MODULE PROCEDURE FMat_VarWriteComplexSingle_1
        MODULE PROCEDURE FMat_VarWriteComplexSingle_2
        MODULE PROCEDURE FMat_VarWriteComplexSingle_3
        MODULE PROCEDURE FMat_VarWriteInt32_0
        MODULE PROCEDURE FMat_VarWriteInt32_1
        MODULE PROCEDURE FMat_VarWriteInt32_2
        MODULE PROCEDURE FMat_VarWriteInt32_3
        MODULE PROCEDURE FMat_VarWriteInt16_0
        MODULE PROCEDURE FMat_VarWriteInt16_1
        MODULE PROCEDURE FMat_VarWriteInt16_2
        MODULE PROCEDURE FMat_VarWriteInt16_3
        MODULE PROCEDURE FMat_VarWriteInt8_0
        MODULE PROCEDURE FMat_VarWriteInt8_1
        MODULE PROCEDURE FMat_VarWriteInt8_2
        MODULE PROCEDURE FMat_VarWriteInt8_3
    END INTERFACE

    INTERFACE FMat_VarWriteData
        MODULE PROCEDURE FMat_VarWriteDoubleData_0
        MODULE PROCEDURE FMat_VarWriteDoubleData_1
        MODULE PROCEDURE FMat_VarWriteDoubleData_2
        MODULE PROCEDURE FMat_VarWriteDoubleData_3
        MODULE PROCEDURE FMat_VarWriteComplexDoubleData_0
        MODULE PROCEDURE FMat_VarWriteComplexDoubleData_1
        MODULE PROCEDURE FMat_VarWriteComplexDoubleData_2
        MODULE PROCEDURE FMat_VarWriteComplexDoubleData_3
        MODULE PROCEDURE FMat_VarWriteSingleData_0
        MODULE PROCEDURE FMat_VarWriteSingleData_1
        MODULE PROCEDURE FMat_VarWriteSingleData_2
        MODULE PROCEDURE FMat_VarWriteSingleData_3
        MODULE PROCEDURE FMat_VarWriteComplexSingleData_0
        MODULE PROCEDURE FMat_VarWriteComplexSingleData_1
        MODULE PROCEDURE FMat_VarWriteComplexSingleData_2
        MODULE PROCEDURE FMat_VarWriteComplexSingleData_3
        MODULE PROCEDURE FMat_VarWriteInt32Data_0
        MODULE PROCEDURE FMat_VarWriteInt32Data_1
        MODULE PROCEDURE FMat_VarWriteInt32Data_2
        MODULE PROCEDURE FMat_VarWriteInt32Data_3
        MODULE PROCEDURE FMat_VarWriteInt16Data_0
        MODULE PROCEDURE FMat_VarWriteInt16Data_1
        MODULE PROCEDURE FMat_VarWriteInt16Data_2
        MODULE PROCEDURE FMat_VarWriteInt16Data_3
        MODULE PROCEDURE FMat_VarWriteInt8Data_0
        MODULE PROCEDURE FMat_VarWriteInt8Data_1
        MODULE PROCEDURE FMat_VarWriteInt8Data_2
        MODULE PROCEDURE FMat_VarWriteInt8Data_3
        MODULE PROCEDURE FMat_VarWriteCharData_0
        MODULE PROCEDURE FMat_VarWriteCharData_1
        MODULE PROCEDURE FMat_VarWriteCharData_2
        MODULE PROCEDURE FMat_VarWriteCharData_3
    END INTERFACE

CONTAINS

!----------------------------------------------------------
!   FMat_LogInit
!
!   Initilize the logging functions
!
!   prog_name: Name of program/function initializing log functions
!----------------------------------------------------------
    SUBROUTINE FMat_LogInit(prog_name)
        CHARACTER(LEN=*) :: prog_name

        CALL fmat_loginit_c(prog_name)
    END SUBROUTINE FMat_LogInit

!----------------------------------------------------------
!   FMat_Open
!
!   Opens a Matlab file
!
!   filename: Name of the matlab file
!   mode:     Mode to open the file. One of MAT_ACC_*
!   mat:      mat_t output structure containing the file information
!----------------------------------------------------------
    FUNCTION FMat_Open(filename,mode,mat) RESULT(err)
    IMPLICIT NONE
        CHARACTER(LEN=*),INTENT(IN)  :: filename
        INTEGER,INTENT(IN)           :: mode
        TYPE(mat_t),INTENT(OUT)      :: mat
        INTEGER                      :: err
        INTEGER,EXTERNAL :: fmat_open_c

        err = fmat_open_c(filename,mode,mat)
    END FUNCTION FMat_Open

!----------------------------------------------------------
!   FMat_Create
!
!   Create a Matlab file
!
!   filename:     Name of the matlab file
!   mat_file_ver: MAT file version to create (MAT_FT_*)
!   mat:          mat_t output structure containing the file information
!   header:       Optional 116 character string to write as the MAT file header
!----------------------------------------------------------
    FUNCTION FMat_Create(filename,mat_file_ver,mat,header) RESULT(err)
    IMPLICIT NONE
        CHARACTER(LEN=*),INTENT(IN)           :: filename
        INTEGER,INTENT(IN)                    :: mat_file_ver
        CHARACTER(LEN=*),INTENT(IN),OPTIONAL  :: header
        TYPE(mat_t),INTENT(OUT)               :: mat
        INTEGER                               :: err
        INTEGER,EXTERNAL :: fmat_create_c

        IF ( .NOT. PRESENT(header) ) THEN
            err = fmat_create_c(filename,mat_file_ver,mat,nullptr)
        ELSE
            err = fmat_create_c(filename,mat_file_ver,mat,header)
        END IF
    END FUNCTION FMat_Create

!----------------------------------------------------------
!   FMat_Close
!
!   Closes an open Matlab file
!
!   mat: mat_t structure containing the file information
!----------------------------------------------------------
    FUNCTION FMat_Close(mat) RESULT(err)
        INTEGER  (KIND=4) err
        TYPE(mat_t),INTENT(INOUT)  :: mat

        err = fmat_close_c(mat)
    END FUNCTION FMat_Close

!----------------------------------------------------------
!   FMat_VarPrint
!
!   Prints a Matlab variable's information and optionally the data
!
!   matvar: matvar_t structure containing the variable information
!----------------------------------------------------------
    SUBROUTINE FMat_VarPrint(matvar)
        TYPE(matvar_t),INTENT(IN)  :: matvar

        CALL fmat_varprint_c(matvar)
    END SUBROUTINE FMat_VarPrint

!----------------------------------------------------------
!   FMat_VarReadInfo
!
!   Reads the information for a variable from the file in mat
!
!   mat:     mat_t structure containing the Matlab file information
!   varname: Name of the variable to read
!   matvar:  output matvar_t structure containing the variable information
!
!   err: 0 on success
!----------------------------------------------------------
    FUNCTION FMat_VarReadInfo(mat,varname,matvar) RESULT(err)
        TYPE(mat_t),   INTENT(INOUT)         :: mat
        CHARACTER(*),  INTENT(IN)            :: varname
        TYPE(matvar_t),INTENT(OUT)           :: matvar
        INTEGER                              :: err
        INTEGER,EXTERNAL                     :: fmat_varreadinfo_c

        err = fmat_varreadinfo_c(mat,varname,matvar)
    END FUNCTION FMAT_VARREADINFO

!----------------------------------------------------------
!   FMat_VarReadInfo
!
!   Reads the information for a variable from the file in mat
!
!   mat:     mat_t structure containing the Matlab file information
!   varname: Name of the variable to read
!   matvar:  output matvar_t structure containing the variable information
!
!   err: 0 on success
!----------------------------------------------------------
    FUNCTION FMat_VarReadNextInfo(mat,matvar) RESULT(err)
        TYPE(mat_t),   INTENT(INOUT)         :: mat
        TYPE(matvar_t),INTENT(OUT)           :: matvar
        INTEGER                              :: err
        INTEGER,EXTERNAL                     :: fmat_varreadnextinfo_c

        err = fmat_varreadnextinfo_c(mat,matvar)
    END FUNCTION FMat_VarReadNextInfo

!----------------------------------------------------------
!   FMat_VarRead
!
!   Reads a variable from the file in mat
!
!   mat:     mat_t structure containing the Matlab file information
!   varname: Name of the variable to read
!   matvar:  output matvar_t structure containing the variable
!
!   err: 0 on success
!----------------------------------------------------------
    FUNCTION FMat_VarRead(mat,varname,matvar) RESULT(err)
        TYPE(mat_t),INTENT(INOUT)          :: mat
        CHARACTER(*),INTENT(OUT)           :: varname
        TYPE(matvar_t),INTENT(OUT)         :: matvar
        INTEGER(4)                         :: err

        err = fmat_varread_c(mat,varname,matvar)
    END FUNCTION FMAT_VARREAD

    FUNCTION FMat_VarWriteInfo(mat,matvar) RESULT(err)
        TYPE(mat_t),INTENT(INOUT)           :: mat
        TYPE(matvar_t),INTENT(INOUT)        :: matvar

        err = fmat_varwriteinfo_c(mat,matvar)
    END FUNCTION

    FUNCTION FMat_VarFree(matvar) RESULT(err)
        TYPE(matvar_t)         :: matvar
        INTEGER(4)             :: err

        err = fmat_varfree_c(matvar)
    END FUNCTION FMAT_VARFREE

    FUNCTION FMat_VarGetStuctFieldByName(struct,field_name,struct_index,  &
                                         field) RESULT(err)
        TYPE(MATVAR_T),INTENT(IN)  :: struct
        CHARACTER(LEN=*)           :: field_name
        INTEGER,INTENT(IN)         :: struct_index
        TYPE(MATVAR_T),INTENT(OUT) :: field
        INTEGER,EXTERNAL           :: fmat_vargetstructfield_byname_c

        err = fmat_vargetstructfield_byname_c(struct,field_name,          &
            struct_index,field)
    END FUNCTION FMat_VarGetStuctFieldByName

    FUNCTION FMat_VarGetNumberOfFields(struct) RESULT(nfields)
        TYPE(MATVAR_T),INTENT(IN)  :: struct
        INTEGER,EXTERNAL           :: fmat_vargetnumberoffields_c

        nfields = fmat_vargetnumberoffields_c(struct)
    END FUNCTION FMat_VarGetNumberOfFields

!   Include the fmat_varcreate interface routines
    INCLUDE 'create.f90'

!   Include the fmat_varreaddata interface routines
    INCLUDE 'read_data.f90'

!   Include the fmat_varwrite interface routines
    INCLUDE 'write.f90'

!   Include the fmat_varwritedata interface routines
    INCLUDE 'write_data.f90'

END MODULE matio

!----------------------------------------------------------
!   FMat_VarReadData Interface procedures
!
!   This files should be included on the MATIO module
!----------------------------------------------------------
!
! Copyright (C) 2005-2016   Christopher C. Hulbert
!
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
!    1. Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!    2. Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
! THIS SOFTWARE IS PROVIDED BY CHRISTOPHER C. HULBERT ``AS IS'' AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER C. HULBERT OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
! CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
! SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
! CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!

FUNCTION FMat_VarReadDoubleData_0(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=8),INTENT(OUT)                    :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadDoubleData_0

FUNCTION FMat_VarReadDoubleData_1(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=8),INTENT(OUT),DIMENSION(:)       :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadDoubleData_1

FUNCTION FMat_VarReadDoubleData_2(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=8),INTENT(OUT),DIMENSION(:,:)     :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadDoubleData_2

FUNCTION FMat_VarReadDoubleData_3(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=8),INTENT(OUT),DIMENSION(:,:,:)   :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadDoubleData_3

FUNCTION FMat_VarReadComplexDoubleData_0(mat,matvar,d,start,stride,edge) &
                                                             RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    DOUBLE COMPLEX,INTENT(OUT)                  :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadComplexDoubleData_0

FUNCTION FMat_VarReadComplexDoubleData_1(mat,matvar,d,start,stride,edge) &
                                                             RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    DOUBLE COMPLEX,INTENT(OUT),DIMENSION(:)     :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    DOUBLE PRECISION,DIMENSION(2*SIZE(d))       :: d_split
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d_split,start,stride,edge)
        d = CMPLX(d_split(1:SIZE(d)),d_split(SIZE(d)+1:))
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
        d = CMPLX(d_split(1:SIZE(d)),d_split(SIZE(d)+1:))
    ENDIF
END FUNCTION FMat_VarReadComplexDoubleData_1

FUNCTION FMat_VarReadComplexDoubleData_2(mat,matvar,d,start,stride,edge) &
                                                             RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    DOUBLE COMPLEX,INTENT(OUT),DIMENSION(:,:)   :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    DOUBLE PRECISION,DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d_split,start,stride,edge)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ENDIF
END FUNCTION FMat_VarReadComplexDoubleData_2

FUNCTION FMat_VarReadComplexDoubleData_3(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    DOUBLE COMPLEX,INTENT(OUT),DIMENSION(:,:,:) :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    DOUBLE PRECISION,DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d_split,start,stride,edge)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ENDIF
END FUNCTION FMat_VarReadComplexDoubleData_3

FUNCTION FMat_VarReadSingleData_0(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=4),INTENT(OUT)                    :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadSingleData_0

FUNCTION FMat_VarReadSingleData_1(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=4),INTENT(OUT),DIMENSION(:)       :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadSingleData_1

FUNCTION FMat_VarReadSingleData_2(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=4),INTENT(OUT),DIMENSION(:,:)     :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadSingleData_2

FUNCTION FMat_VarReadSingleData_3(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    REAL(KIND=4),INTENT(OUT),DIMENSION(:,:,:)   :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadSingleData_3

FUNCTION FMat_VarReadComplexSingleData_0(mat,matvar,d,start,stride,edge) &
                                                             RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    COMPLEX(4),INTENT(OUT)                  :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadComplexSingleData_0

FUNCTION FMat_VarReadComplexSingleData_1(mat,matvar,d,start,stride,edge) &
                                                             RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    COMPLEX(4),INTENT(OUT),DIMENSION(:)     :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    REAL(4),DIMENSION(2*SIZE(d))       :: d_split
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d_split,start,stride,edge)
        d = CMPLX(d_split(1:SIZE(d)),d_split(SIZE(d)+1:))
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
        d = CMPLX(d_split(1:SIZE(d)),d_split(SIZE(d)+1:))
    ENDIF
END FUNCTION FMat_VarReadComplexSingleData_1

FUNCTION FMat_VarReadComplexSingleData_2(mat,matvar,d,start,stride,edge) &
                                                             RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    COMPLEX(4),INTENT(OUT),DIMENSION(:,:)   :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    REAL(4),DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d_split,start,stride,edge)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ENDIF
END FUNCTION FMat_VarReadComplexSingleData_2

FUNCTION FMat_VarReadComplexSingleData_3(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    COMPLEX(4),INTENT(OUT),DIMENSION(:,:,:) :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    REAL(4),DIMENSION(2*PRODUCT(SHAPE(d))) :: d_split
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d_split,start,stride,edge)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d_split,nullptr,nullptr,nullptr)
        d = CMPLX(RESHAPE(d_split(1:PRODUCT(SHAPE(d))),SHAPE(d)),         &
                  RESHAPE(d_split(PRODUCT(SHAPE(d))+1:),SHAPE(d)))
    ENDIF
END FUNCTION FMat_VarReadComplexSingleData_3

FUNCTION FMat_VarReadInt32Data_0(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=4),INTENT(OUT)                 :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadInt32Data_0

FUNCTION FMAT_VARREADINT32DATA_1(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=4),INTENT(OUT),DIMENSION(:)    :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT32DATA_1

FUNCTION FMAT_VARREADINT32DATA_2(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=4),INTENT(OUT),DIMENSION(:,:)  :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT32DATA_2

FUNCTION FMAT_VARREADINT32DATA_3(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                   :: err
    TYPE(mat_t)                                  :: mat
    TYPE(matvar_t)                               :: matvar
    INTEGER(KIND=4),INTENT(OUT),DIMENSION(:,:,:) :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: edge
    INTEGER,EXTERNAL                             :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT32DATA_3

FUNCTION FMat_VarReadInt16Data_0(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=2),INTENT(OUT)                 :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadInt16Data_0

FUNCTION FMAT_VARREADINT16DATA_1(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=2),INTENT(OUT),DIMENSION(:)    :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT16DATA_1

FUNCTION FMAT_VARREADINT16DATA_2(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=2),INTENT(OUT),DIMENSION(:,:)  :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT16DATA_2

FUNCTION FMAT_VARREADINT16DATA_3(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                   :: err
    TYPE(mat_t)                                  :: mat
    TYPE(matvar_t)                               :: matvar
    INTEGER(KIND=2),INTENT(OUT),DIMENSION(:,:,:) :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: edge
    INTEGER,EXTERNAL                             :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT16DATA_3

FUNCTION FMat_VarReadInt8Data_0(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=1),INTENT(OUT)                 :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadInt8Data_0

FUNCTION FMAT_VARREADINT8DATA_1(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=1),INTENT(OUT),DIMENSION(:)    :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT8DATA_1

FUNCTION FMAT_VARREADINT8DATA_2(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    INTEGER(KIND=1),INTENT(OUT),DIMENSION(:,:)  :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT8DATA_2

FUNCTION FMAT_VARREADINT8DATA_3(mat,matvar,d,start,stride,edge) &
                                                       RESULT(err)
    INTEGER(4)                                   :: err
    TYPE(mat_t)                                  :: mat
    TYPE(matvar_t)                               :: matvar
    INTEGER(KIND=1),INTENT(OUT),DIMENSION(:,:,:) :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL  :: edge
    INTEGER,EXTERNAL                             :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMAT_VARREADINT8DATA_3

FUNCTION FMat_VarReadCharData_0(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    CHARACTER(1),INTENT(OUT)                    :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadCharData_0

FUNCTION FMat_VarReadCharData_1(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    CHARACTER(1),INTENT(OUT),DIMENSION(:)       :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadCharData_1

FUNCTION FMat_VarReadCharData_2(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    CHARACTER(1),INTENT(OUT),DIMENSION(:,:)     :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadCharData_2

FUNCTION FMat_VarReadCharData_3(mat,matvar,d,start,stride,edge) RESULT(err)
    INTEGER(4)                                  :: err
    TYPE(mat_t)                                 :: mat
    TYPE(matvar_t)                              :: matvar
    CHARACTER(1),INTENT(OUT),DIMENSION(:,:,:)   :: d
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: start
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: stride
    INTEGER(4),INTENT(IN),DIMENSION(*),OPTIONAL :: edge
    INTEGER,EXTERNAL                            :: fmat_varreaddata_c

    IF ( PRESENT(start) .AND. PRESENT(stride) .AND. PRESENT(edge) ) THEN
        err = fmat_varreaddata_c(mat,matvar,d,start,stride,edge)
    ELSEIF ( PRESENT(start) .OR. PRESENT(stride) .OR. PRESENT(edge) ) THEN
        err = 1    ! Must have all 3 or none
    ELSE
        err = fmat_varreaddata_c(mat,matvar,d,nullptr,nullptr,nullptr)
    ENDIF
END FUNCTION FMat_VarReadCharData_3

!
! Copyright (C) 2005-2016   Christopher C. Hulbert
!
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
!    1. Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!    2. Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
! THIS SOFTWARE IS PROVIDED BY CHRISTOPHER C. HULBERT ``AS IS'' AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER C. HULBERT OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
! CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
! SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
! CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!
FUNCTION FMat_VarCreateA(rank,dims,name,class_type,data_type,matvar) RESULT(err)
    INTEGER(4)                         :: err
    INTEGER(4),INTENT(IN)              :: rank
    INTEGER(4),INTENT(IN)              :: class_type
    INTEGER(4),INTENT(IN)              :: data_type
    INTEGER(4),INTENT(IN),DIMENSION(*) :: dims
    CHARACTER(LEN=*) :: name
    TYPE(matvar_t),INTENT(INOUT)        :: matvar

    err = fmat_varcreate_c(rank,dims,name,class_type,matvar%data_type,matvar)
END FUNCTION

FUNCTION FMat_VarCreateDouble0(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE PRECISION                :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateDouble0

FUNCTION FMat_VarCreateDouble1(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE PRECISION,DIMENSION(:)   :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(double_data)
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateDouble1

FUNCTION FMat_VarCreateDouble2(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE PRECISION,DIMENSION(:,:) :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(double_data,1)
    matvar%dims(2)    = SIZE(double_data,2)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateDouble2

FUNCTION FMat_VarCreateDouble3(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE PRECISION,DIMENSION(:,:,:) :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(double_data,1)
    matvar%dims(2)    = SIZE(double_data,2)
    matvar%dims(3)    = SIZE(double_data,3)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateDouble3

FUNCTION FMat_VarCreateComplexDouble0(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE COMPLEX                  :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexDouble0

FUNCTION FMat_VarCreateComplexDouble1(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE COMPLEX,DIMENSION(:)   :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(double_data)
    matvar%dims(2)    = 1
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexDouble1

FUNCTION FMat_VarCreateComplexDouble2(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE COMPLEX,DIMENSION(:,:)   :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(double_data,1)
    matvar%dims(2)    = SIZE(double_data,2)
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexDouble2

FUNCTION FMat_VarCreateComplexDouble3(varname,double_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    DOUBLE COMPLEX,DIMENSION(:,:,:) :: double_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_DOUBLE
    matvar%data_type  = MAT_T_DOUBLE
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(double_data,1)
    matvar%dims(2)    = SIZE(double_data,2)
    matvar%dims(3)    = SIZE(double_data,3)
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexDouble3

FUNCTION FMat_VarCreateSingle0(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    REAL(4)                         :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateSingle0

FUNCTION FMat_VarCreateSingle1(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    REAL(4),DIMENSION(:)   :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(single_data)
    matvar%dims(2)    = 1
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateSingle1

FUNCTION FMat_VarCreateSingle2(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    REAL(4),DIMENSION(:,:) :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(single_data,1)
    matvar%dims(2)    = SIZE(single_data,2)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateSingle2

FUNCTION FMat_VarCreateSingle3(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    REAL(4),DIMENSION(:,:,:) :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(single_data,1)
    matvar%dims(2)    = SIZE(single_data,2)
    matvar%dims(3)    = SIZE(single_data,3)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateSingle3

FUNCTION FMat_VarCreateComplexSingle0(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    COMPLEX(4)                      :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexSingle0

FUNCTION FMat_VarCreateComplexSingle1(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    COMPLEX(4),DIMENSION(:)    :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(single_data)
    matvar%dims(2)    = 1
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexSingle1

FUNCTION FMat_VarCreateComplexSingle2(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    COMPLEX(4),DIMENSION(:,:)   :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(single_data,1)
    matvar%dims(2)    = SIZE(single_data,2)
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexSingle2

FUNCTION FMat_VarCreateComplexSingle3(varname,single_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    COMPLEX(4),DIMENSION(:,:,:)     :: single_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_SINGLE
    matvar%data_type  = MAT_T_SINGLE
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(single_data,1)
    matvar%dims(2)    = SIZE(single_data,2)
    matvar%dims(3)    = SIZE(single_data,3)
    matvar%isComplex  = 1
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateComplexSingle3

FUNCTION FMat_VarCreateInt32_0(varname,int32_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(4)                      :: int32_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT32
    matvar%data_type  = MAT_T_INT32
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt32_0

FUNCTION FMat_VarCreateInt32_1(varname,int32_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(4),DIMENSION(:)   :: int32_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT32
    matvar%data_type  = MAT_T_INT32
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(int32_data)
    matvar%dims(2)    = 1
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt32_1

FUNCTION FMat_VarCreateInt32_2(varname,int32_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(4),DIMENSION(:,:) :: int32_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT32
    matvar%data_type  = MAT_T_INT32
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(int32_data,1)
    matvar%dims(2)    = SIZE(int32_data,2)

    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt32_2

FUNCTION FMat_VarCreateInt32_3(varname,int32_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(4),DIMENSION(:,:,:) :: int32_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT32
    matvar%data_type  = MAT_T_INT32
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(int32_data,1)
    matvar%dims(2)    = SIZE(int32_data,2)
    matvar%dims(3)    = SIZE(int32_data,3)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt32_3

FUNCTION FMat_VarCreateInt16_0(varname,int16_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(2)                      :: int16_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT16
    matvar%data_type  = MAT_T_INT16
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt16_0

FUNCTION FMat_VarCreateInt16_1(varname,int16_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(2),DIMENSION(:)   :: int16_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT16
    matvar%data_type  = MAT_T_INT16
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(int16_data)
    matvar%dims(2)    = 1
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt16_1

FUNCTION FMat_VarCreateInt16_2(varname,int16_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(2),DIMENSION(:,:) :: int16_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT16
    matvar%data_type  = MAT_T_INT16
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(int16_data,1)
    matvar%dims(2)    = SIZE(int16_data,2)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt16_2

FUNCTION FMat_VarCreateInt16_3(varname,int16_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(2),DIMENSION(:,:,:) :: int16_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT16
    matvar%data_type  = MAT_T_INT16
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(int16_data,1)
    matvar%dims(2)    = SIZE(int16_data,2)
    matvar%dims(3)    = SIZE(int16_data,3)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt16_3

FUNCTION FMat_VarCreateInt8_0(varname,int8_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(1)                      :: int8_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT8
    matvar%data_type  = MAT_T_INT8
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt8_0

FUNCTION FMat_VarCreateInt8_1(varname,int8_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(1),DIMENSION(:)   :: int8_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT8
    matvar%data_type  = MAT_T_INT8
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(int8_data)
    matvar%dims(2)    = 1
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt8_1

FUNCTION FMat_VarCreateInt8_2(varname,int8_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(1),DIMENSION(:,:) :: int8_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT8
    matvar%data_type  = MAT_T_INT8
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(int8_data,1)
    matvar%dims(2)    = SIZE(int8_data,2)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt8_2

FUNCTION FMat_VarCreateInt8_3(varname,int8_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    INTEGER(1),DIMENSION(:,:,:) :: int8_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_INT8
    matvar%data_type  = MAT_T_INT8
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(int8_data,1)
    matvar%dims(2)    = SIZE(int8_data,2)
    matvar%dims(3)    = SIZE(int8_data,3)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateInt8_3

FUNCTION FMat_VarCreateChar_0(varname,char_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    CHARACTER                       :: char_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_CHAR
    matvar%data_type  = MAT_T_UINT8
    matvar%rank       = 2
    matvar%dims(1)    = 1
    matvar%dims(2)    = 1
    matvar%isComplex  = 0
    matvar%isGlobal   = 0
    matvar%isLogical  = 0
    matvar%name       = varname
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,          &
                           matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateChar_0

FUNCTION FMat_VarCreateChar_1(varname,char_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    CHARACTER(1),DIMENSION(:)       :: char_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_CHAR
    matvar%data_type  = MAT_T_UINT8
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(char_data)
    matvar%dims(2)    = 1
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateChar_1

FUNCTION FMat_VarCreateChar_2(varname,char_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    CHARACTER(1),DIMENSION(:,:)     :: char_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_CHAR
    matvar%data_type  = MAT_T_UINT8
    matvar%rank       = 2
    matvar%dims(1)    = SIZE(char_data,1)
    matvar%dims(2)    = SIZE(char_data,2)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateChar_2

FUNCTION FMat_VarCreateChar_3(varname,char_data,matvar) RESULT(err)
IMPLICIT NONE
    INTEGER                         :: err
    CHARACTER(LEN=*)                :: varname
    CHARACTER(1),DIMENSION(:,:,:)   :: char_data
    TYPE(matvar_t),INTENT(INOUT)    :: matvar

    INTEGER,EXTERNAL                :: fmat_varcreate_c

    matvar%class_type = MAT_C_CHAR
    matvar%data_type  = MAT_T_UINT8
    matvar%rank       = 3
    matvar%dims(1)    = SIZE(char_data,1)
    matvar%dims(2)    = SIZE(char_data,2)
    matvar%dims(3)    = SIZE(char_data,3)
    err = fmat_varcreate_c(matvar%rank,matvar%dims,varname,matvar%class_type,matvar%data_type,matvar)
END FUNCTION FMat_VarCreateChar_3

!
! Copyright (C) 2005-2016   Christopher C. Hulbert
!
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
!    1. Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!    2. Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
! THIS SOFTWARE IS PROVIDED BY CHRISTOPHER C. HULBERT ``AS IS'' AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL CHRISTOPHER C. HULBERT OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
! CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
! SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
! CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!
PROGRAM test
USE MATIO
IMPLICIT NONE
    CHARACTER(len=4)                :: prog_name
    INTEGER                         :: opt
    INTEGER(KIND=4)                 :: mode, err, i,rank, class_type,data_type
    TYPE(mat_t)                     :: mat
    TYPE(matvar_t)                  :: matvar,field

    prog_name = 'test'
    CALL FMAT_LOGINIT(prog_name)

    DO
        WRITE (*,*) '   Version 5 MAT File tests'
        WRITE (*,*) '========================================================='
        WRITE (*,*) ' 1.  copy           - Copies one matlab file to another'
        WRITE (*,*) ' 2.  write          - Writes a matlab file'
        WRITE (*,*) ' 3.  readvar        - Reads a specific variable from a file'
        WRITE (*,*) ' 4.  writestruct    - Writes a structure'
        WRITE (*,*) ' 5.  writecell      - Writes a Cell Array'
        WRITE (*,*) ' 6.  getstructfield - Uses Mat_VarGetStructField to get fields from a structure'
        WRITE (*,*) ' 7.  readvarinfo    - Reads a variables header information only'
        WRITE (*,*) ' 8.  readslab       - Tests reading a part of a dataset'
        WRITE (*,*) ' 9.  writeslab      - Tests writing a part of a dataset'
        WRITE (*,*) ' 10. writesparse    - Tests writing a sparse matrix'
        WRITE (*,*) ' 11. writecompressed - Tests writing a compressed file'
        WRITE (*,*) ''
        WRITE (*,*) ''
        WRITE (*,*) '   Version 4 MAT File tests'
        WRITE (*,*) '========================================================='
        WRITE (*,*) ''
        WRITE (*,*) ''
        WRITE (*,*) '   Other Tests'
        WRITE (*,*) '========================================================='
        WRITE (*,*) '101. ind2sub - Calculates a set of subscripts from a linear index'
        WRITE (*,*) '102. sub2ind - Calculates the linear index from subscript values'
        WRITE (*,*) '999.  Exit'
        WRITE (*,*) ''
        WRITE (*,'(a)',ADVANCE='NO') 'Select a test: '
        READ (*,'(i3)') opt

        SELECT CASE (opt)
            CASE (999)
                EXIT
            CASE (1)
                CALL test_copy
            CASE (2)
                CALL test_write
            CASE (3)
                CALL test_readvar
            CASE (4)
                CALL test_writestruct
            CASE (5)
                CALL test_writecell
            CASE (6)
                CALL test_getstructfield
            CASE (7)
                CALL test_readvarinfo
            CASE (8)
                CALL test_readslab
            CASE (9)
                CALL test_writeslab
            CASE (10)
                CALL test_writesparse
            CASE (11)
                CALL test_write_compressed
            CASE DEFAULT
                WRITE (*,*) ''
                WRITE (*,*) 'Invalid option!'
                WRITE (*,*) ''
        END SELECT
    END DO

CONTAINS
    SUBROUTINE test_copy
    USE MATIO
    IMPLICIT NONE
        DOUBLE PRECISION,ALLOCATABLE :: double_data(:)
        REAL(4),ALLOCATABLE          :: single_data(:)
        INTEGER(4),ALLOCATABLE       :: int32_data(:)
        INTEGER(2),ALLOCATABLE       :: int16_data(:)
        INTEGER(1),ALLOCATABLE       :: int8_data(:)
        INTEGER            :: err,N
        TYPE(matvar_t)     :: matvar
        TYPE(mat_t)        :: mat,mat2
        CHARACTER(LEN=128) :: inputfile
        CHARACTER(LEN=17)  :: outfilename

        outfilename = 'test_mat_copy.mat'
        WRITE (*,'(a)',ADVANCE='NO') 'Enter the input filename: '
        READ (*,'(a128)') inputfile

        err = FMat_Open(inputfile,MAT_ACC_RDWR,mat)
        err = FMat_Create(outfilename,MAT_FT_MAT5,mat2)
        IF ( err .NE. 0 ) THEN
            WRITE (*,*) 'Error opening file ',inputfile
            RETURN
        ELSE
            err = FMat_VarReadNextInfo(mat,matvar)
            DO WHILE ( err .EQ. 0 )
                N = PRODUCT(matvar%dims(1:matvar%rank))
                IF ( matvar%isComplex .GT. 0 ) N=N*2
                SELECT CASE (matvar%class_type)
                    CASE (MAT_C_DOUBLE)
                        ALLOCATE(double_data(N))
                        err = FMat_VarReadData(mat,matvar,double_data)
                        err = FMat_VarWrite(mat2,matvar,double_data)
                        DEALLOCATE(double_data)
                    CASE (MAT_C_SINGLE)
                        ALLOCATE(single_data(N))
                        err = FMat_VarReadData(mat,matvar,single_data)
                        err = FMat_VarWrite(mat2,matvar,single_data)
                        DEALLOCATE(single_data)
                    CASE (MAT_C_INT32,MAT_C_UINT32)
                        ALLOCATE(int32_data(N))
                        err = FMat_VarReadData(mat,matvar,int32_data)
                        err = FMat_VarWrite(mat2,matvar,int32_data)
                        DEALLOCATE(int32_data)
                    CASE (MAT_C_INT16,MAT_C_UINT16)
                        ALLOCATE(int16_data(N))
                        err = FMat_VarReadData(mat,matvar,int16_data)
                        err = FMat_VarWrite(mat2,matvar,int16_data)
                        DEALLOCATE(int16_data)
                    CASE (MAT_C_INT8,MAT_C_UINT8)
                        ALLOCATE(int8_data(N))
                        err = FMat_VarReadData(mat,matvar,int8_data)
                        err = FMat_VarWrite(mat2,matvar,int8_data)
                        DEALLOCATE(int8_data)
                END SELECT
                err = FMat_VarReadNextInfo(mat,matvar)
            END DO
            err = FMat_Close(mat)
            err = FMat_Close(mat2)
        END IF
    END SUBROUTINE test_copy

    SUBROUTINE test_write
    USE MATIO
    IMPLICIT NONE
        CHARACTER(LEN=18)  :: filename = 'test_mat_write.mat'
        INTEGER            :: err,k,l,n = 1
        TYPE(MAT_T)        :: mat
        TYPE(MATVAR_T)     :: matvar
        ! Data
        CHARACTER(LEN=3)           :: cdouble_name = 'd_j'
        CHARACTER(LEN=1)           :: double_name = 'd'
        CHARACTER(LEN=1)           :: single_name = 's'
        CHARACTER(LEN=3)           :: int32_name  = 'i32'
        CHARACTER(LEN=3)           :: int16_name  = 'i16'
        CHARACTER(LEN=2)           :: int8_name   = 'i8'
        CHARACTER(LEN=1)           :: char_name   = 'c'
        REAL(8),DIMENSION(5,10)    :: double_data
        COMPLEX(8),DIMENSION(5,10) :: cdouble_data
        REAL(4),DIMENSION(5,10)    :: single_data
        COMPLEX(4),DIMENSION(5,10) :: csingle_data
        INTEGER(4),DIMENSION(5,10) :: int32_data
        INTEGER(2),DIMENSION(5,10) :: int16_data
        INTEGER(1),DIMENSION(5,10) :: int8_data
        CHARACTER(1),DIMENSION(5,10) :: char_data

        double_data  = RESHAPE((/(n,n=1,50)/),(/5,10/))
        cdouble_data = CMPLX(RESHAPE((/(n,n=1,50)/),(/5,10/)),  &
                             RESHAPE((/(n,n=1,50)/),(/5,10/)))
        single_data  = RESHAPE((/(n,n=1,50)/),(/5,10/))
        int32_data   = RESHAPE((/(n,n=1,50)/),(/5,10/))
        int16_data   = RESHAPE((/(n,n=1,50)/),(/5,10/))
        int8_data    = RESHAPE((/(n,n=1,50)/),(/5,10/))

        char_data(1,1)  = 'a'
        char_data(2,1)  = 'b'
        char_data(3,1)  = 'c'
        char_data(4,1)  = 'd'
        char_data(5,1)  = 'e'
        char_data(1,2)  = 'f'
        char_data(2,2)  = 'g'
        char_data(3,2)  = 'h'
        char_data(4,2)  = 'i'
        char_data(5,2) = 'j'
        char_data(1,3) = 'k'
        char_data(2,3) = 'l'
        char_data(3,3) = 'm'
        char_data(4,3) = 'n'
        char_data(5,3) = 'o'
        char_data(1,4) = 'p'
        char_data(2,4) = 'q'
        char_data(3,4) = 'r'
        char_data(4,4) = 's'
        char_data(5,4) = 't'
        char_data(1,5) = 'u'
        char_data(2,5) = 'v'
        char_data(3,5) = 'w'
        char_data(4,5) = 'x'
        char_data(5,5) = 'y'
        char_data(1,6) = 'z'
        char_data(2,6) = '0'
        char_data(3,6) = '1'
        char_data(4,6) = '2'
        char_data(5,6) = '3'
        char_data(1,7) = '4'
        char_data(2,7) = '5'
        char_data(3,7) = '6'
        char_data(4,7) = '7'
        char_data(5,7) = '8'
        char_data(1,8) = '9'
        char_data(2,8) = '!'
        char_data(3,8) = '@'
        char_data(4,8) = '#'
        char_data(5,8) = '$'
        char_data(1,9) = '%'
        char_data(2,9) = '^'
        char_data(3,9) = '&'
        char_data(4,9) = '*'
        char_data(5,9) = '('
        char_data(1,10) = ')'
        char_data(2,10) = '-'
        char_data(3,10) = '+'
        char_data(4,10) = '='
        char_data(5,10) = '~'

        err = FMat_Open(filename,MAT_ACC_RDWR,mat)
        IF ( err .NE. 0 ) THEN
            WRITE (*,*) 'Error opening file ',filename
            RETURN
        ELSE
            err = FMat_VarCreate(double_name,double_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,double_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(cdouble_name,cdouble_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWrite(mat,matvar,cdouble_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(single_name,single_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,single_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int32_name,int32_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,int32_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int16_name,int16_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,int16_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int8_name,int8_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,int8_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(char_name,char_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,char_data)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_Close(mat)
        END IF
    END SUBROUTINE test_write

    SUBROUTINE test_write_compressed
    USE MATIO
    IMPLICIT NONE
        CHARACTER(LEN=64)  :: filename = 'test_mat_write_compressed.mat'
        INTEGER            :: err,k,l,n = 1
        TYPE(MAT_T)        :: mat
        TYPE(MATVAR_T)     :: matvar
        ! Data
        CHARACTER(LEN=1)           :: double_name = 'd'
        CHARACTER(LEN=1)           :: single_name = 's'
        CHARACTER(LEN=3)           :: int32_name  = 'i32'
        CHARACTER(LEN=3)           :: int16_name  = 'i16'
        CHARACTER(LEN=2)           :: int8_name   = 'i8'
        REAL(8),DIMENSION(5,10)    :: double_data
        REAL(4),DIMENSION(5,10)    :: single_data
        INTEGER(4),DIMENSION(5,10) :: int32_data
        INTEGER(2),DIMENSION(5,10) :: int16_data
        INTEGER(1),DIMENSION(5,10) :: int8_data

        double_data = RESHAPE((/(n,n=1,50)/),(/5,10/))
        single_data = RESHAPE((/(n,n=1,50)/),(/5,10/))
        int32_data  = RESHAPE((/(n,n=1,50)/),(/5,10/))
        int16_data  = RESHAPE((/(n,n=1,50)/),(/5,10/))
        int8_data   = RESHAPE((/(n,n=1,50)/),(/5,10/))

        err = FMat_Open(filename,MAT_ACC_RDWR,mat)
        IF ( err .NE. 0 ) THEN
            WRITE (*,*) 'Error opening file ',filename
            RETURN
        ELSE
            err = FMat_VarCreate(double_name,double_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWrite(mat,matvar,double_data,COMPRESSION_ZLIB)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(single_name,single_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWrite(mat,matvar,single_data,COMPRESSION_ZLIB)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int32_name,int32_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWrite(mat,matvar,int32_data,COMPRESSION_ZLIB)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int16_name,int16_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWrite(mat,matvar,int16_data,COMPRESSION_ZLIB)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int8_name,int8_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWrite(mat,matvar,int8_data,COMPRESSION_ZLIB)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_Close(mat)
        END IF
    END SUBROUTINE test_write_compressed

    SUBROUTINE test_readvar
    USE MATIO
    IMPLICIT NONE
        CHARACTER(LEN=128) :: inputfile
        CHARACTER(LEN=32)  :: varname
        TYPE(MAT_T)        :: mat
        TYPE(MATVAR_T)     :: matvar
        INTEGER            :: err,N
        ! Data matrices
        REAL(8),DIMENSION(:),ALLOCATABLE      :: double_data
        REAL(4),DIMENSION(:),ALLOCATABLE      :: single_data
        INTEGER(4),DIMENSION(:),ALLOCATABLE   :: int32_data
        INTEGER(2),DIMENSION(:),ALLOCATABLE   :: int16_data
        INTEGER(1),DIMENSION(:),ALLOCATABLE   :: int8_data
        CHARACTER(1),DIMENSION(:),ALLOCATABLE :: char_data

        WRITE (*,'(a)',ADVANCE='NO') 'Enter the input filename: '
        READ (*,'(a128)') inputfile
        WRITE (*,'(a)',ADVANCE='NO') 'Enter the variable name: '
        READ (*,'(a32)') varname

        err = FMat_Open(inputfile,MAT_ACC_RDONLY,mat)
        IF ( err .NE. 0 ) THEN
            WRITE (*,*) 'Error opening file ',inputfile
            RETURN
        ELSE
            err = FMat_VarReadInfo(mat,varname,matvar)
            IF ( err .NE. 0 ) THEN
                WRITE (*,*) 'err=',err
                RETURN
            END IF
            N = PRODUCT(matvar%dims(1:matvar%rank))
            SELECT CASE (matvar%class_type)
                CASE (MAT_C_DOUBLE)
                    ALLOCATE(double_data(N))
                    err = FMat_VarReadData(mat,matvar,double_data)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) double_data
                    DEALLOCATE(double_data)
                CASE (MAT_C_SINGLE)
                    ALLOCATE(single_data(N))
                    err = FMat_VarReadData(mat,matvar,single_data)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) single_data
                    DEALLOCATE(single_data)
                CASE (MAT_C_INT32,MAT_C_UINT32)
                    ALLOCATE(int32_data(N))
                    err = FMat_VarReadData(mat,matvar,int32_data)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) int32_data
                    DEALLOCATE(int32_data)
                CASE (MAT_C_INT16,MAT_C_UINT16)
                    ALLOCATE(int16_data(N))
                    err = FMat_VarReadData(mat,matvar,int16_data)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) int16_data
                    DEALLOCATE(int16_data)
                CASE (MAT_C_INT8,MAT_C_UINT8)
                    ALLOCATE(int8_data(N))
                    err = FMat_VarReadData(mat,matvar,int8_data)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) int8_data
                    DEALLOCATE(int8_data)
                CASE (MAT_C_CHAR)
                    ALLOCATE(char_data(N))
                    err = FMat_VarReadData(mat,matvar,char_data)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) char_data
                    DEALLOCATE(char_data)
                CASE (MAT_C_STRUCT)
                    err = FMat_VarGetNumberOfFields(matvar)
                    WRITE(*,*) '      Name: ',matvar%name
                    WRITE(*,*) '      Rank: ',matvar%rank
                    WRITE(*,*) '     Class: ',matvar%class_type
                    WRITE(*,*) 'Dimensions: ',matvar%dims(1:matvar%rank)
                    WRITE(*,*) 'Number of Fields: ',err
            END SELECT
            err = FMat_VarFree(matvar)
            err = FMat_Close(mat)
        END IF
    END SUBROUTINE test_readvar

    SUBROUTINE test_writestruct
    END SUBROUTINE test_writestruct
    SUBROUTINE test_writecell
    END SUBROUTINE test_writecell
    SUBROUTINE test_getstructfield
    END SUBROUTINE test_getstructfield
    SUBROUTINE test_readvarinfo
    END SUBROUTINE test_readvarinfo

    SUBROUTINE test_writeslab
    USE MATIO
    IMPLICIT NONE
        CHARACTER(LEN=64)  :: filename = 'test_mat_writeslab.mat'
        INTEGER            :: err,k,l,n = 1
        INTEGER,DIMENSION(2) :: start  = (/0,0/)
        INTEGER,DIMENSION(2) :: stride = (/2,2/)
        INTEGER,DIMENSION(2) :: edge   = (/3,5/)
        TYPE(MAT_T)        :: mat
        TYPE(MATVAR_T)     :: matvar
        ! Data
        CHARACTER(LEN=1)           :: double_name = 'd'
        CHARACTER(LEN=1)           :: single_name = 's'
        CHARACTER(LEN=3)           :: int32_name  = 'i32'
        REAL(8),DIMENSION(6,10)    :: double_data
        REAL(4),DIMENSION(6,10)    :: single_data
        INTEGER(4),DIMENSION(6,10) :: int32_data

        double_data = RESHAPE((/(n,n=1,60)/),(/6,10/))
        single_data = RESHAPE((/(n,n=1,60)/),(/6,10/))
        int32_data  = RESHAPE((/(n,n=1,60)/),(/6,10/))

        err = FMat_Open(filename,MAT_ACC_RDWR,mat)
        IF ( err .NE. 0 ) THEN
            WRITE (*,*) 'Error opening file ',filename
            RETURN
        ELSE
            err = FMat_VarCreate(double_name,double_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,double_data,start,stride,edge)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(single_name,single_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,single_data,start,stride,edge)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_VarCreate(int32_name,int32_data,matvar)
            IF (err .EQ. 0) THEN
                err = FMat_VarWriteInfo(mat,matvar)
                err = FMat_VarWriteData(mat,matvar,int32_data,start,stride,edge)
                err = FMat_VarFree(matvar)
            END IF
            err = FMat_Close(mat)
        END IF
    END SUBROUTINE test_writeslab

    SUBROUTINE test_readslab
    USE MATIO
    IMPLICIT NONE
        CHARACTER(LEN=128) :: inputfile
        CHARACTER(LEN=32)  :: varname
        TYPE(MAT_T)        :: mat
        TYPE(MATVAR_T)     :: matvar
        INTEGER            :: err,N
        INTEGER,DIMENSION(2) :: start  = (/0,0/)
        INTEGER,DIMENSION(2) :: stride = (/1,1/)
        INTEGER,DIMENSION(2) :: edge   = (/2,2/)
        ! Data matrices
        REAL(8),DIMENSION(4)      :: double_data
        REAL(4),DIMENSION(4)      :: single_data
        INTEGER(4),DIMENSION(4)   :: int32_data
        INTEGER(2),DIMENSION(4)   :: int16_data
        INTEGER(1),DIMENSION(4)   :: int8_data

        WRITE (*,'(a)',ADVANCE='NO') 'Enter the input filename: '
        READ (*,'(a128)') inputfile
        WRITE (*,'(a)',ADVANCE='NO') 'Enter the variable name: '
        READ (*,'(a32)') varname

        err = FMat_Open(inputfile,MAT_ACC_RDONLY,mat)
        IF ( err .NE. 0 ) THEN
            WRITE (*,*) 'Error opening file ',inputfile
            RETURN
        ELSE
            err = FMat_VarReadInfo(mat,varname,matvar)
            IF ( err .NE. 0 ) THEN
                WRITE (*,*) 'err=',err
                RETURN
            END IF
            SELECT CASE (matvar%class_type)
                CASE (MAT_C_DOUBLE)
                    stride(1) = matvar%dims(1)-1
                    stride(2) = matvar%dims(2)-1
                    err = FMat_VarReadData(mat,matvar,double_data,start,stride,edge)
                    WRITE(*,*) double_data
                CASE (MAT_C_SINGLE)
                    stride(1) = matvar%dims(1)-1
                    stride(2) = matvar%dims(2)-1
                    err = FMat_VarReadData(mat,matvar,single_data,start,stride,edge)
                    WRITE(*,*) single_data
                CASE (MAT_C_INT32,MAT_C_UINT32)
                    stride(1) = matvar%dims(1)-1
                    stride(2) = matvar%dims(2)-1
                    err = FMat_VarReadData(mat,matvar,int32_data,start,stride,edge)
                    WRITE(*,*) int32_data
                CASE (MAT_C_INT16,MAT_C_UINT16)
                    stride(1) = matvar%dims(1)-1
                    stride(2) = matvar%dims(2)-1
                    err = FMat_VarReadData(mat,matvar,int16_data,start,stride,edge)
                    WRITE(*,*) int16_data
                CASE (MAT_C_INT8,MAT_C_UINT8)
                    stride(1) = matvar%dims(1)-1
                    stride(2) = matvar%dims(2)-1
                    err = FMat_VarReadData(mat,matvar,int8_data,start,stride,edge)
                    WRITE(*,*) int8_data
            END SELECT
            err = FMat_VarFree(matvar)
            err = FMat_Close(mat)
        END IF
    END SUBROUTINE test_readslab

    SUBROUTINE test_writesparse
    END SUBROUTINE test_writesparse

END PROGRAM test

:: Configure
set CONF=Release
if "%ARCH%" == "32" (
  set SLN_PLAT=Win32
) else (
  set SLN_PLAT=x64
)

if "%VS_YEAR%" == "2015" (
  set TOOLSET=v140
  set SLN_FILE="visual_studio\matio.sln"
)
if "%VS_YEAR%" == "" (
  echo Unknown VS version
  exit 1
)

echo %LIBRARY_PREFIX%

:: Build
msbuild "%SLN_FILE%" ^
  /p:Configuration=Release ^
  /p:Platform=%SLN_PLAT% ^
  /p:PlatformToolset=%TOOLSET% ^
  /property:HDF5_DIR=%LIBRARY_PREFIX%
if errorlevel 1 exit 1

:: Install
copy %SRC_DIR%\visual_studio\%SLN_PLAT%\Release\libmatio.dll %LIBRARY_BIN%\
if errorlevel 1 exit 1
copy %SRC_DIR%\visual_studio\%SLN_PLAT%\Release\libmatio.lib %LIBRARY_LIB%\
if errorlevel 1 exit 1
copy %SRC_DIR%\src\matio.h %LIBRARY_INC%\
if errorlevel 1 exit 1
copy %SRC_DIR%\visual_studio\matio_pubconf.h %LIBRARY_INC%\
if errorlevel 1 exit 1

#!/bin/bash

./configure \
  --enable-mat73 \
  --with-pic \
  --enable-extended-sparse \
  --prefix="${PREFIX}" \
  --with-zlib="${PREFIX}" \
  --with-hdf5="${PREFIX}"
make

if [[ `uname` == 'Darwin' ]];
then
	eval DYLD_FALLBACK_LIBRARY_PATH=$PREFIX/lib make check
else
	make check
fi

make install

if not exist %PREFIX%\Library\bin\libmatio.dll exit 1
IF %ERRORLEVEL% NEQ 0 exit /B 1
if not exist %PREFIX%\Library\lib\libmatio.lib exit 1
IF %ERRORLEVEL% NEQ 0 exit /B 1
if not exist %PREFIX%\Library\include\matio.h exit 1
IF %ERRORLEVEL% NEQ 0 exit /B 1
exit /B 0
